#include <stdlib.h>

void foo3_initcall()		/* initialize routine for module */
{
	/* start debug print out */
	printf("===> foo3 initcall has been run\n");
	/* end debug print out */
}

extern void register_initcall(	/* external routine to register initcall */
        void (*initcall)(),
        char *tag,
        char **run_first_list
        );

void register_foo3_initcall()	/* local routine to register initcall */
{
	static char *tag="foo3";	/* tag for initialize routine */
	static char *run_first_list[]={	/* routines to be run first */
		NULL };

	register_initcall(foo3_initcall,
			  tag,
			  run_first_list
			  );
	
	/* start debug print out */
	int i=0;
	printf("%s has been registered\n  First run:", tag);
	while (run_first_list[i] != NULL)
		printf(" %s", run_first_list[i++]);
	printf("\n");
	/* end debug print out */
}
